Index: cpukit/Makefile.am
===================================================================
--- cpukit/Makefile.am	(revision 8b0e752fee90af946e0e117ca7d46a7df7814d14)
+++ cpukit/Makefile.am	(revision 0f5b2c0906e77863d86dda2c91e32f9ab1983fdf)
@@ -1021,4 +1021,5 @@
 librtemscpu_a_SOURCES += sapi/src/fatal.c
 librtemscpu_a_SOURCES += sapi/src/fatalsrctext.c
+librtemscpu_a_SOURCES += sapi/src/getconfigmax.c
 librtemscpu_a_SOURCES += sapi/src/getversionstring.c
 librtemscpu_a_SOURCES += sapi/src/interrtext.c
Index: cpukit/include/rtems/config.h
===================================================================
--- cpukit/include/rtems/config.h	(revision 8b0e752fee90af946e0e117ca7d46a7df7814d14)
+++ cpukit/include/rtems/config.h	(revision 0f5b2c0906e77863d86dda2c91e32f9ab1983fdf)
@@ -277,6 +277,5 @@
             0 : rtems_configuration_get_stack_space_size()))
 
-#define rtems_configuration_get_maximum_extensions() \
-        (Configuration.maximum_extensions)
+uint32_t rtems_configuration_get_maximum_extensions( void );
 
 #define rtems_configuration_get_microseconds_per_tick() \
Index: cpukit/include/rtems/rtems/config.h
===================================================================
--- cpukit/include/rtems/rtems/config.h	(revision 8b0e752fee90af946e0e117ca7d46a7df7814d14)
+++ cpukit/include/rtems/rtems/config.h	(revision 0f5b2c0906e77863d86dda2c91e32f9ab1983fdf)
@@ -127,9 +127,21 @@
 /**@}*/
 
-/**
- *  This macro returns the number of Classic API semaphores configured.
- */
-#define rtems_configuration_get_maximum_semaphores() \
-        rtems_configuration_get_rtems_api_configuration()->maximum_semaphores
+uint32_t rtems_configuration_get_maximum_barriers( void );
+
+uint32_t rtems_configuration_get_maximum_message_queues( void );
+
+uint32_t rtems_configuration_get_maximum_partitions( void );
+
+uint32_t rtems_configuration_get_maximum_periods( void );
+
+uint32_t rtems_configuration_get_maximum_ports( void );
+
+uint32_t rtems_configuration_get_maximum_regions( void );
+
+uint32_t rtems_configuration_get_maximum_semaphores( void );
+
+uint32_t rtems_configuration_get_maximum_timers( void );
+
+uint32_t rtems_configuration_get_maximum_tasks( void );
 
 #ifdef __cplusplus
Index: cpukit/libmisc/monitor/mon-config.c
===================================================================
--- cpukit/libmisc/monitor/mon-config.c	(revision 8b0e752fee90af946e0e117ca7d46a7df7814d14)
+++ cpukit/libmisc/monitor/mon-config.c	(revision 0f5b2c0906e77863d86dda2c91e32f9ab1983fdf)
@@ -35,13 +35,13 @@
 
     canonical_config->work_space_size = c->work_space_size;
-    canonical_config->maximum_tasks = r->maximum_tasks;
-    canonical_config->maximum_timers = r->maximum_timers;
-    canonical_config->maximum_semaphores = r->maximum_semaphores;
-    canonical_config->maximum_message_queues = r->maximum_message_queues;
-    canonical_config->maximum_partitions = r->maximum_partitions;
-    canonical_config->maximum_regions = r->maximum_regions;
-    canonical_config->maximum_ports = r->maximum_ports;
-    canonical_config->maximum_periods = r->maximum_periods;
-    canonical_config->maximum_extensions = c->maximum_extensions;
+    canonical_config->maximum_tasks = rtems_configuration_get_maximum_tasks();
+    canonical_config->maximum_timers = rtems_configuration_get_maximum_timers();
+    canonical_config->maximum_semaphores = rtems_configuration_get_maximum_semaphores();
+    canonical_config->maximum_message_queues = rtems_configuration_get_maximum_message_queues();
+    canonical_config->maximum_partitions = rtems_configuration_get_maximum_partitions();
+    canonical_config->maximum_regions = rtems_configuration_get_maximum_regions();
+    canonical_config->maximum_ports = rtems_configuration_get_maximum_ports();
+    canonical_config->maximum_periods = rtems_configuration_get_maximum_periods();
+    canonical_config->maximum_extensions = rtems_configuration_get_maximum_extensions();
     canonical_config->microseconds_per_tick = c->microseconds_per_tick;
     canonical_config->ticks_per_timeslice = c->ticks_per_timeslice;
Index: cpukit/sapi/src/extension.c
===================================================================
--- cpukit/sapi/src/extension.c	(revision 8b0e752fee90af946e0e117ca7d46a7df7814d14)
+++ cpukit/sapi/src/extension.c	(revision 0f5b2c0906e77863d86dda2c91e32f9ab1983fdf)
@@ -34,5 +34,5 @@
     OBJECTS_CLASSIC_API,                 /* object API */
     OBJECTS_RTEMS_EXTENSIONS,
-    rtems_configuration_get_maximum_extensions(),
+    Configuration.maximum_extensions,
     sizeof( Extension_Control ),
     OBJECTS_NO_STRING_NAME,    /* maximum length of an object name */
Index: cpukit/sapi/src/getconfigmax.c
===================================================================
--- cpukit/sapi/src/getconfigmax.c	(revision 0f5b2c0906e77863d86dda2c91e32f9ab1983fdf)
+++ cpukit/sapi/src/getconfigmax.c	(revision 0f5b2c0906e77863d86dda2c91e32f9ab1983fdf)
@@ -0,0 +1,102 @@
+/*
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (C) 2018 embedded brains GmbH
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <rtems/config.h>
+#include <rtems/extensionimpl.h>
+#include <rtems/rtems/barrierimpl.h>
+#include <rtems/rtems/dpmemimpl.h>
+#include <rtems/rtems/messageimpl.h>
+#include <rtems/rtems/partimpl.h>
+#include <rtems/rtems/ratemonimpl.h>
+#include <rtems/rtems/regionimpl.h>
+#include <rtems/rtems/semimpl.h>
+#include <rtems/rtems/tasksimpl.h>
+#include <rtems/rtems/timerimpl.h>
+#include <rtems/score/objectimpl.h>
+
+static uint32_t get_config_max( const Objects_Information *info )
+{
+	if ( _Objects_Is_auto_extend( info ) ) {
+		return info->objects_per_block | RTEMS_UNLIMITED_OBJECTS;
+	}
+
+	return _Objects_Get_maximum_index( info );
+}
+
+uint32_t rtems_configuration_get_maximum_barriers( void )
+{
+	return get_config_max( &_Barrier_Information );
+}
+
+uint32_t rtems_configuration_get_maximum_extensions( void )
+{
+	return get_config_max( &_Extension_Information );
+}
+
+uint32_t rtems_configuration_get_maximum_message_queues( void )
+{
+	return get_config_max( &_Message_queue_Information );
+}
+
+uint32_t rtems_configuration_get_maximum_partitions( void )
+{
+	return get_config_max( &_Partition_Information );
+}
+
+uint32_t rtems_configuration_get_maximum_periods( void )
+{
+	return get_config_max( &_Rate_monotonic_Information );
+}
+
+uint32_t rtems_configuration_get_maximum_ports( void )
+{
+	return get_config_max( &_Dual_ported_memory_Information );
+}
+
+uint32_t rtems_configuration_get_maximum_regions( void )
+{
+	return get_config_max( &_Region_Information );
+}
+
+uint32_t rtems_configuration_get_maximum_semaphores( void )
+{
+	return get_config_max( &_Semaphore_Information );
+}
+
+uint32_t rtems_configuration_get_maximum_timers( void )
+{
+	return get_config_max( &_Timer_Information );
+}
+
+uint32_t rtems_configuration_get_maximum_tasks( void )
+{
+	return get_config_max( &_RTEMS_tasks_Information.Objects );
+}
